medux_online/core/urls.py
from django.contrib.auth import views as auth_views
from django.urls import path, include

import medux.common.views
import medux_online.core.views as views
from medux.common.api.interfaces import IHTMXComponentMixin
from .api.interfaces import IDashboardURL

app_name = "core"

tenant_patterns = [
    path("", views.TenantListView.as_view(), name="list"),
    path("add/", views.TenantCreateView.as_view(), name="add"),
    path("<pk>/", views.TenantUpdateView.as_view(), name="detail"),
    path("<pk>/change/", views.TenantUpdateView.as_view(), name="update"),
    path("<pk>/delete/", views.TenantDeleteView.as_view(), name="delete"),
    path("<uuid:uuid>/privacy", views.PrivacyView.as_view(), name="privacy"),
    path("<uuid:uuid>/terms", views.TermsView.as_view(), name="terms"),
]

preferences_patterns = [
    path("", views.BasePreferenceListView.as_view(), name="overview"),
    # ScopedPreference CRUD
    path(
        "basepreference/<base_pk>/add-<str:scope>/",
        views.ScopedPreferenceCreateView.as_view(),
        name="add",
    ),
    path(
        "basepreference/<pk>/",
        views.BasePreferenceDetailView.as_view(),
        name="base-detail",
    ),
    path(
        "scopedpreference/<int:pk>/",
        # scopedpreference_detail,
        views.ScopedPreferenceDetailView.as_view(),
        name="detail",
    ),
    path(
        "scopedpreference/<int:pk>/update/",
        views.scopedpreference_update,
        name="update",
    ),
    path(
        "scopedpreference/<int:pk>/delete/",
        views.ScopedPreferenceDeleteView.as_view(),
        name="delete",
    ),
    path("set-tenant/<int:pk>/", views.set_active_tenant, name="set-tenant"),
]
# user_profile_patterns = [
#     # user:profile: namespace
#     path("masterdata", views.UserProfileMasterDataView.as_view(), name="master-data"),
#     path("password", views.UserProfilePasswordView.as_view(), name="password"),
#     path("groups", views.UserProfileGroupsView.as_view(), name="groups"),
# ]
user_patterns = [
    # user: namespace
    path("", views.UserListView.as_view(), name="list"),
    path(
        "<int:pk>/detail/", medux.common.views.UserUpdateView.as_view(), name="detail"
    ),
    path("add/", views.UserCreateView.as_view(), name="add"),
    path(
        "<int:pk>/update/", medux.common.views.UserUpdateView.as_view(), name="update"
    ),
    path("<int:pk>/delete/", views.UserDeleteView.as_view(), name="delete"),
    path("profile/", medux.common.views.UserProfileView.as_view(), name="profile"),
]

root_urlpatterns = [
    path("auth/", auth_views.PasswordChangeView.as_view()),
    # FIXME: should be included in Conjunto...
    # path(
    #     "__elements__/",
    #     include(
    #         (IHtmxComponentMixin.get_url_patterns(), "components"),
    #         namespace="components",
    #     ),
    # ),
]


class CoreDashboardURLs(IDashboardURL):
    urlpatterns = [
        path("tenant/", include((tenant_patterns, "tenant"), namespace="tenant")),
        path(
            "preferences/",
            include((preferences_patterns, "preferences"), namespace="preferences"),
        ),
        path(
            "user/",
            include((user_patterns, "user"), namespace="user"),
        ),
    ]

medux_online/urls.py
from functools import wraps

from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.core.exceptions import PermissionDenied
from django.urls import path, include
from gdaps.pluginmanager import PluginManager

from .core.api.interfaces import IDashboardURL
from .core.views import DashboardView

app_name = "medux_online"


def medux_site_required(test_func=None):
    """
    Decorator for views that checks that the current site is the main
    medux site. If not, raise a PermissionDenied error
    """

    def site_is_medux(view_func):
        @wraps(view_func)
        def _wrapped_view(request, *args, **kwargs):
            if request.site == 1:
                return True
            raise PermissionDenied

        return _wrapped_view

    return site_is_medux


# create a pluggable "dashboard" urlpatterns hook
dashboard_urlpatterns = [
    path("", DashboardView.as_view(), name="index"),
]
for up in IDashboardURL:
    dashboard_urlpatterns += up.urlpatterns

urlpatterns = [
    # TODO make admin only available on SIDE_ID=1
    path("admin/", admin.site.urls, name="admin"),
    path(
        "dashboard/",
        # dashboard is no namespace, only part of the URL
        include((dashboard_urlpatterns, ""), namespace=""),
        name="index",
    ),
    path("__debug__/", include("debug_toolbar.urls")),
] + PluginManager.urlpatterns()

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

medux_online/plugins/homepage/models.py
from datetime import datetime
from pathlib import Path

from colorfield.fields import ColorField
from django.contrib.auth.signals import user_logged_in
from django.contrib.sites.models import Site
from django.core.files.storage import Storage
from django.core.validators import MinValueValidator, MaxValueValidator, validate_slug
from django.db import models
from django.shortcuts import redirect
from django.urls import reverse_lazy
from django.utils.text import slugify, re_camel_case
from django.utils.translation import gettext_lazy as _
from polymorphic.models import PolymorphicModel

# FIXME: Bah, that ZipExtractorStorage can't work.
from medux.common.models import TenantModelMixin


# from zipfile import ZipFile
# # thanks to https://goodcode.io/articles/django-singleton-models/
# class SingletonModel(models.Model):
#     class Meta:
#         abstract = True
#
#     def save(self, *args, **kwargs):
#         self.__class__.objects.exclude(id=self.id).delete()
#         super(SingletonModel, self).save(*args, **kwargs)
#
#     @classmethod
#     def load(cls):
#         try:
#             return cls.objects.get()
#         except cls.DoesNotExist:
#             return cls()


class ZipExtractorStorage(Storage):
    """Dummy"""

    def save(self, name, content, max_length=None):
        # with ZipFile(name) as zip_file:
        #     upload_path = self.get_upload_path(self, self.package.name)
        #     zip_file.extractall(self.get_upload_path() / self.slug)
        #     # TODO: do something with uploaded file
        pass


class Theme(models.Model):
    # TODO: determine a way to allow only own tenant's themes, or to explicitly allow others, per theme
    def get_upload_path(self, instance: "Theme", filename: str):
        return Path("themes")  # / instance.homepage.name

    slug = models.CharField(max_length=64, validators=[validate_slug])
    title = models.CharField(max_length=255)
    package = models.FileField(
        upload_to=get_upload_path, storage=ZipExtractorStorage, null=True, blank=True
    )

    def __str__(self):
        return self.title

    def save(self, *args, **kwargs):

        if not self.slug:
            self.slug = slugify(self.title)
        super().save(*args, **kwargs)


class ColoredMixin(models.Model):
    class Meta:
        abstract = True

    color_accent = ColorField()
    text_primary = ColorField()
    text_secondary = ColorField()
    text_success = ColorField()
    text_danger = ColorField()
    text_warning = ColorField()
    text_info = ColorField()
    text_light = ColorField()
    text_dark = ColorField()
    text_muted = ColorField()
    text_white = ColorField()

    bg_primary = ColorField()
    bg_secondary = ColorField()
    bg_light = ColorField()
    bg_dark = ColorField()


class Homepage(TenantModelMixin, Site):
    subtitle = models.CharField(
        _("Subtitle"),
        help_text=_("A subtitle that appears on the homepage, depending on the theme."),
        max_length=255,
        blank=True,
        null=True,
    )
    logo = models.ImageField(
        _("Logo"), help_text=_("Homepage Logo"), blank=True, null=True
    )

    theme = models.ForeignKey(Theme, default=1, on_delete=models.SET_DEFAULT)

    def __str__(self):
        return self.name


class MultiHomepagesMixin(models.Model):
    """A mixin that can be added to a model to mark it as belonging to more than one homepage."""

    class Meta:
        abstract = True

    homepages = models.ManyToManyField(Homepage)


class SingleHomepageMixin(models.Model):
    """A mixin that can be added to a model to mark it as belonging to exactly one homepage."""

    class Meta:
        abstract = True

    homepage = models.ForeignKey(Homepage, on_delete=models.CASCADE)


# Note: SingleHomepageMixin is 2nd in the list, so that objects is called first from PolymorphicModel.
# This is needed for PolymorphicModel to get no ManagerInheritanceWarning.
class Block(PolymorphicModel):
    """A basic HTML/renderable block.

    You can either create a Block directly, and fill out the title and content, and it will be rendered
    as HTML. The order of the block is determined by the "weight" property: the higher the weight, the
    "deeper" sinks the block down.

    If you subclass Block, you can add model fields. Just make sure you add these fields to the
    "additional_fields" list property, so they will be added to the template context.
    """

    class Meta:
        verbose_name = _("Common block")
        verbose_name_plural = _("Common blocks")

    homepage = models.ForeignKey(
        Homepage, on_delete=models.CASCADE, related_name="blocks"
    )

    #: should the title be editable?
    edit_title = False
    #: should the content be editable
    edit_content = False

    additional_fields = []
    template_name = "block.html"

    title = models.CharField(_("Title"), max_length=50, blank=True)
    show_title = models.BooleanField(
        default=True, verbose_name=_("Show title on homepage")
    )
    content = models.TextField(_("Content"), blank=True)
    weight = models.SmallIntegerField(_("Weight"), default=0)

    visible = models.BooleanField(_("Visible"), default=False)

    # def __str__(self):
    # (
    #     f"{self.title} ({self.tenant.name})"
    #     if self.title
    #     else f"{self._meta.verbose_name.capitalize()} ({self.tenant.name})"
    # )

    def verbose_name(self):
        return self._meta.verbose_name

    def btype(self) -> str:
        """:returns the block type (=basically the lowercase class name) as string."""
        class_name = self.__class__.__name__
        return re_camel_case.sub(r"_\1", class_name).strip("_").lower()

    def __str__(self):
        return f"{self.title} ({self.homepage})"

    @property
    def tenant(self):
        return self.homepage.tenant


class Header(Block):
    class Meta:
        verbose_name = _("Header")
        verbose_name_plural = _("Headers")

    template_name = "header.html"
    additional_fields = ["logo", "background_image"]

    logo = models.ImageField(blank=True, null=True)
    background_image = models.ImageField(blank=True, null=True)


class News(Block):
    class Meta:
        verbose_name = _("News")
        verbose_name_plural = _("News")

    template_name = "news.html"


class OpeningHours(Block):
    """Opening hours, that can be rendered in a block"""

    class Meta:
        verbose_name = _("Opening hours")
        verbose_name_plural = _("Opening hours")

    template_name = "opening_hours.html"
    additional_fields = ["entries", "weekdays_count"]

    def weekdays_count(self) -> int:
        """returns distinct count of week days that are open.

        E.g. if opening hours are MO 8-12, WE 8-12 + 15-18, FR 8-12; then it would return 3."""
        # FIXME: use a distinct call
        return self.entries.count()


class OpeningHourSlot(models.Model):
    """Single block of opening hours, e.g. '8:00 - 12:00'"""

    DAYS_CHOICES = (
        (0, _("MO")),
        (1, _("TU")),
        (2, _("WE")),
        (3, _("TH")),
        (4, _("FR")),
        (5, _("SA")),
        (6, _("SU")),
    )
    day = models.PositiveSmallIntegerField(
        choices=DAYS_CHOICES,
        validators=[MinValueValidator(0), MaxValueValidator(6)],
        null=True,
    )
    start = models.TimeField()
    end = models.TimeField()
    opening_hours = models.ForeignKey(
        OpeningHours, on_delete=models.CASCADE, related_name="entries"
    )

    def __str__(self) -> str:
        return f"{self.day_str()}, {self.start} - {self.end}"

    def is_today(self) -> bool:
        return datetime.today().weekday() == self.day

    def day_str(self) -> str:
        """returns the day as (translated) 2 char str."""
        return self.DAYS_CHOICES[self.day][1]


class Map(Block):
    """A Block with a GDPR-compliant map image pointing to a OSM, Google Maps, or other map service point."""

    class Meta:
        verbose_name = _("Map")
        verbose_name_plural = _("Maps")

    template_name = "map.html"
    additional_fields = ["address", "link_image", "location_url"]

    address = models.CharField(max_length=128, verbose_name=_("Address"))
    link_image = models.ImageField(upload_to="map_images", blank=True, null=True)
    location_url = models.URLField(
        max_length=255,
        verbose_name=_("Location URL"),
        help_text=_("Link that points to OpenStreetMap, Google Maps etc."),
    )


class Contact(Block):
    class Meta:
        verbose_name = _("Contact")
        verbose_name_plural = _("Contacts")

    def get_homepage_email(self):
        return self.tenant.email  # FIXME

    additional_fields = ["email"]
    template_name = "contact.html"

    email = models.EmailField()


class Team(Block):
    class Meta:
        verbose_name = _("Team")
        verbose_name_plural = _("Teams")

    template_name = "team.html"
    additional_fields = ["members"]


class TeamMember(SingleHomepageMixin, models.Model):
    """A team member with a name, function, description and photo."""

    class Meta:
        verbose_name = _("Team member")
        verbose_name_plural = _("Team members")

    @staticmethod
    def _get_team():
        pass

    team = models.ForeignKey(Team, on_delete=models.CASCADE, related_name="members")
    name = models.CharField(_("Name"), max_length=50)
    function = models.CharField(_("Function"), max_length=50, blank=True)
    description = models.TextField(_("Description"), blank=True)
    image = models.ImageField(_("Photo"), blank=True, null=True)

    def __str__(self):
        return self.name

    def save(
        self, force_insert=False, force_update=False, using=None, update_fields=None
    ):
        # FIXME: make homepage links work
        team, created = Team.objects.get_or_create(homepage=self.homepage)
        if created:
            team.tenant = self.homepage.foo

        self.team = team
        super().save(force_insert, force_update, using, update_fields)

medux_online/core/forms/tenant.py
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout, Row, Column, Submit
from django import forms
from django.utils.translation import gettext_lazy as _

from medux.common.models import Tenant, SexChoices


# TODO: TenantFormFixin to enable tenant aware generic forms.
# class TenantFormMixin:
#     """A mixin that adds the current request's tenant to the form data.
#
#     Make sure the view using this form has :class:`TenantViewMixin` included.
#     """
#
#     def __init__(self, *args, **kwargs):
#         self.tenant = kwargs["initial"].pop("tenant")
#         super().__init__(self, *args, **kwargs)
#
#     def clean(self):
#         super().clean()
#         self.cleaned_data["tenant_id"] = self.tenant.id


class TenantForm(forms.ModelForm):
    class Meta:
        model = Tenant
        exclude = ["uuid"]

    sex = forms.ChoiceField(
        label=_("Sex"),
        choices=SexChoices.choices,
        # widget=RadioSelectButtonGroup,
    )

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.helper = FormHelper(self)
        self.helper.layout = Layout(
            Row(Column("title"), Column("first_name"), Column("last_name")),
            Row(
                Column("sex"),  # Field("sex", css_class="btn-check")
                Column("address"),
                Column("phone"),
                Column("email"),
            ),
        )
        self.helper.add_input(Submit("submit", _("Save")))
        if self.instance.pk:
            self.helper.add_input(Submit("delete", _("Delete"), css_class="btn-danger"))

medux_online/core/templates/core/base.html
{% extends "common/html.html" %}
{% load static %}

{# FIXME: replace with conjunto #}
{#{% block body %}#}
{#  <div class="page">#}
{#    <!-- sidebar -->#}
{#    <aside class="navbar navbar-vertical navbar-expand-lg navbar-light">#}
{#      <div class="container-fluid">#}
{#        {% block sidebar %}#}
{#          <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar-menu">#}
{#            <span class="navbar-toggler-icon"></span>#}
{#          </button>#}
{#          <h1 class="navbar-brand navbar-brand-autodark">#}
{#            {% block brand %}{% endblock %}#}
{#          </h1>#}
{#          <div class="navbar-nav flex-row d-lg-none">#}
{#            <div class="d-none d-lg-flex">#}
              {#            {% include 'common/widgets/theme_toggler.html' %}#}
{#              {% include 'common/widgets/notification_dropdown.html' %}#}
{#            </div>#}
{#            {% include 'common/widgets/user_menu.html' %}#}
{#          </div>#}
{#          <div class="collapse navbar-collapse" id="navbar-menu">#}
{#            {% include 'common/widgets/vertical_menu.html' with menu=menus.views %}#}
{#          </div>#}
{#        {% endblock %}#}
{#      </div>#}
{#    </aside>#}
{#    <!-- end sidebar -->#}
{#    {% include 'common/layout/navbar.html' %}#}
{#    {% block canvas %}{% endblock %}#}
{#  </div>#}
{#{% endblock %}#}
{##}

medux_online/core/templates/core/change_password.html
{% extends" 'modal.html'" %}

medux_online/core/templates/core/staticpage.html
{% extends "common/html.html" %}
{% load i18n static %}
{# template for simple "static" pages, like tems&conditions, GDPR info etc. #}
{# header_bgd_color: e.g. #12345 to colorize the background of th header according to tenant's color scheme #}
{# nav_buttons: buttons/links in top right corner (header) #}
{# page_pretitle: pre title, rendered above the title, smaller #}
{# page_title: the title of the page #}
{# page_actions: block in right top corner ov page_header #}
{# content: self-explanatory #}
{# footer: footer content #}
{% block body %}
  <div class="page">
    <!-- Navbar -->
    <header class="navbar navbar-expand-md navbar-light d-print-none"
        {# TODO: default preferences color here... #}
            style="background-color:{% block header_bg_color %}{% endblock %};"
    >
      <div class="container-xl">
        <h1 class="navbar-brand navbar-brand-autodark d-none-navbar-horizontal pe-0 pe-md-3">
          {% block brand %}
            <a href=".">
              <img src="./static/logo.svg" alt="{{ globals.project_title }}" class="navbar-brand-image" width="110" height="32">
            </a>
          {% endblock %}
        </h1>
        <div class="navbar-nav flex-row order-md-last">
          <div class="nav-item d-none d-md-flex me-3">
            <div class="btn-list">
              {% block nav_buttons %}
              {% endblock %}
            </div>
          </div>
        </div>
      </div>
    </header>
    <div class="page-wrapper">
      <!-- Page header -->
      {% block page_header %}
        <div class="page-header d-print-none">
          <div class="container-xl">
            <div class="row g-2 align-items-center">
              <div class="col-12">
                <h2 class="page-title">
                  {% block page_title %}{% endblock %}
                </h2>
              </div>
            </div>
          </div>
        </div>
      {% endblock %}
      <!-- Page body -->
      <div class="page-body">
        <div class="container-xl">
          {% block content %}{% endblock %}
        </div>
      </div>

      <footer class="footer footer-transparent d-print-none">
        <div class="container-xl">
          {% block footer %}
            <div class="row text-center align-items-center flex-row-reverse">
              <div class="col-lg-auto ms-lg-auto">
                <ul class="list-inline list-inline-dots mb-0">
                  <li class="list-inline-item"><a href="{% url 'tenant:privacy' uuid=tenant.uuid %}" class="link-secondary">{% translate 'Privacy' %}</a></li>
                  <li class="list-inline-item"><a href="{% url 'tenant:terms' uuid=tenant.uuid %}" class="link-secondary">{% translate 'Terms' %}</a></li>
{#                  <li class="list-inline-item">#}
{#                    <a href="." target="_blank" class="link-secondary" rel="noopener">#}
{#                      <i class="bi bi-heart-fill text-red small"></i>#}
{#                      Sponsor#}
{#                    </a>#}
{#                  </li>#}
                </ul>
              </div>
              <div class="col-12 col-lg-auto mt-3 mt-lg-0">
                <ul class="list-inline list-inline-dots mb-0">
                  <li class="list-inline-item">
                    Copyright © {% now "Y" %}
                    <a href="https://nerdocs.at" class="link-secondary">nerdocs</a>
                  </li>
                  <li class="list-inline-item">
                    MedUX Online v{{ globals.version }}
                  </li>
                </ul>
              </div>
            </div>
          {% endblock %}

        </div>
      </footer>
    </div>
  </div>
{% endblock %}

medux_online/core/templates/core/tenant_form.html
{% extends "core/page.html" %}
{% load i18n crispy_forms_tags gdaps %}

{% block page_title %}
  {% if tenant %}
    {{ tenant.last_name | upper }}, {{ tenant.first_name }}
  {% else %}
    {% translate 'Add new tenant' %}
  {% endif %}
{% endblock %}

{% block content %}

  <div class="card mb-2">
    {% if tenant %}
      <div class="card-header card-header-light">
        <div>
          <div class="row align-items-center">
            <div class="col-auto">
              <span class="avatar" style="background-image: url({{ tenant.picture }})"></span>
            </div>
            <div class="col">
              <div class="card-title">{{ tenant }}</div>
              <div class="card-subtitle text-black-50">{{ tenant.uuid }}</div>
            </div>
          </div>
        </div>

        <div class="card-actions btn-actions menu-tenant-detail">
          {#  <div class="dropdown"> #}
          {#    <a href="#" class="btn-action dropdown-toggle" data-bs-toggle="dropdown" #}
          {#        aria-haspopup="true" aria-expanded="false"> #}
          {#        <i class="bi bi-three-dots-vertical"></i> #}
          {#    </a> #}
          {#    <div class="dropdown-menu dropdown-menu-end"> #}
          {#      <a class="dropdown-item" href="#">Edit user</a> #}
          {#      <a class="dropdown-item" href="#">Change permissions</a> #}
          {#      <a class="dropdown-item text-danger" href="#">Delete user</a> #}
          {#    </div> #}
          {#  </div> #}
          {% for item in menus.tenant_detail_actions %}
            <a href='{{ item.url }}' type='button' class="btn btn-action">
              <i class="bi bi-{{ item.icon }}"></i>
            </a>
          {% endfor %}
        </div>
      </div>
    {% endif %}

    <div class="card-body">
      <div class='row'>
        <div class='col'>
          <form action="." method="post">
            {% csrf_token %}
            {% crispy form %}
          </form>
        </div>
      </div>
    </div>
  </div>

  {% if tenant %}
    <!-- Tenant users -->
    <div class="card mb-3">
      <div class="card-header">
        <h3 class="card-title">{% translate 'Users' %}</h3>
      </div>
      <div class="card-body">
        <table class="table table-vcenter card-table">
          <thead>
          <tr>
            <th>{% translate 'Username' %}</th>
            <th>{% translate 'Name' %}</th>
            <th>{% translate 'Actions' %}</th>
          </tr>
          </thead>
          <tbody>
          {% for tenant_user in tenant.user_set.all %}
            <tr>
              <td><a href="{% url 'user:update' tenant_user.pk %}">{{ tenant_user.username }}</a></td>
              <td class="text-muted">
                {{ tenant_user }}
              </td>
              <td>
                <a class="btn btn-danger btn-sm{% if tenant_user.pk == 1 %} disabled{% endif %} "
                   href="{% url 'user:delete' pk=tenant_user.pk %}">
                  <i class="bi bi-x-lg"></i>
                </a>
              </td>
            </tr>
          {% endfor %}
          </tbody>
        </table>
      </div>
    </div>
  {% endif %}

  {% if tenant %}
    {% render_plugins ITenantDetailAddon %}
  {% endif %}
{% endblock %}

medux_online/core/templates/core/tenant_list.html
{% extends "core/page.html" %}
{% load i18n %}

{% block title %}
  {% translate 'Administration' %} - {% translate 'Tenants' %}
{% endblock %}

{% block page_title %}
  {% translate 'Tenants' %}
{% endblock %}

{% block page_menu %}
  <a class="btn btn-sm btn-outline-secondary" href="{% url 'tenant:add' %}"><i class="bi bi-plus-lg"></i></a>
{% endblock %}

{% block content %}
  <div class="container-fluid">
    <div class="col-12">
      <div class="card">
        {# <div class="card-header">#}
        {#   <h3 class="card-title">People</h3>#}
        {# </div>#}
        <div class="list-group list-group-flush overflow-auto" style="max-height: 35rem">
          {% for tenant in tenants %}
            {% with tenant.last_name|first|upper as initial %}
              {% ifchanged initial %}
                <div class="list-group-header sticky-top">{{ initial }}</div>
              {% endifchanged %}

              <div class="list-group-item">
                <div class="row">
                  <div class="col-auto">
                    <a href="{% url 'tenant:detail' tenant.pk %}">
                      <span class="avatar" style="background-image: url({{ tenant.picture }})"></span>
                    </a>
                  </div>
                  <div class="col text-truncate">
                    <a href="{% url 'tenant:detail' tenant.pk %}" class="text-body d-block fs-2">
                      {{ tenant }}</a>
                    <div class="text-muted text-truncate mt-n1">
                      <i class='bi bi-envelope'></i>
                      {{ tenant.address }}
                    </div>
                  </div>
                  <div class="col d-none d-md-block text-truncate">
                    <div class="text-muted text-truncate mt-n1">
                      <i class='bi bi-telephone'></i>
                      {{ tenant.phone }}
                    </div>
                    <div class="text-muted text-truncate mt-n1">
                      <span class='fs-6'>@</span>
                      <a href="mailto:{{ tenant.email }}">{{ tenant.email|default:"" }}</a>
                    </div>
                  </div>
                  <div class="col text-truncate">
                    <ul class='list-unstyled'>
                      {% for homepage in tenant.homepage_set.all %}
                        <li class='list'>{{ homepage.domain }}</li>
                      {% endfor %}
                    </ul>
                  </div>
                </div>
              </div>

            {% endwith %}
          {% endfor %}

        </div>
      </div>
    </div>
  </div>
{% endblock %}